// print_complex().

// General includes.
#include "cl_sysdep.h"

// Specification.
#include "cl_output.h"


// Implementation.

#include "cl_complex.h"
#include "cl_C.h"
#include "cl_real.h"
#include "cl_R.h"

cl_boolean cl_print_complex_readably = cl_false;

void print_complex (cl_ostream stream, const cl_N& z)
{
	var cl_R re = realpart(z);
	var cl_R im = imagpart(z);
	if (cl_print_complex_readably) {
		// Common Lisp #C(re im) syntax
		fprintchar(stream,'#');
		fprintchar(stream,'C');
		fprintchar(stream,'(');
		print_real(stream,re);
		fprintchar(stream,' ');
		print_real(stream,im);
		fprintchar(stream,')');
	} else {
		// Standard mathematical notation: re + im i
		if (!eq(im,0)) {
			if (!eq(re,0)) {
				// Example: 3-7i
				print_real(stream,re);
				if (minusp(im)) {
					fprintchar(stream,'-');
					print_real(stream,-im);
				} else {
					fprintchar(stream,'+');
					print_real(stream,im);
				}
				fprintchar(stream,'i');
			} else {
				// Example: 6i
				print_real(stream,im);
				fprintchar(stream,'i');
			}
		} else {
			// Example: 8
			print_real(stream,re);
		}
	}
}
